package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ArContentChild;
import com.izouma.awesomeadmin.service.ArContentChildService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/arContentChild")
public class ArContentChildController {

    @Autowired
    private ArContentChildService arContentChildService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ArContentChild record) {
        List<ArContentChild> pp = arContentChildService.getArContentChildList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getArContentChild", method = RequestMethod.GET)
    @ResponseBody
    public Result getArContentChild(@RequestParam(required = false, value = "id") String id) {
        ArContentChild data = arContentChildService.getArContentChildById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ArContentChild record) {
        ArContentChild data = arContentChildService.getArContentChild(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ArContentChild record) {
        Map<String, Object> result = new HashMap<>();

        List<ArContentChild> pp =arContentChildService.getArContentChildByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ArContentChild record) {
        boolean num = arContentChildService.createArContentChild(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateArContentChild(ArContentChild record) {
        boolean num = arContentChildService.updateArContentChild(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteArContentChild(ArContentChild record) {

        boolean num = arContentChildService.deleteArContentChild(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ArContentChild record) throws Exception {

    List<ArContentChild> arContentChilds = arContentChildService.getArContentChildList(record);


        String sheetName = "ar_content_child";
        String titleName = "AR内容子集数据表";
        String fileName = "AR内容子集表";
        int columnNumber = 23;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "AR内容ID" ,   "类型" ,   "字段1" ,   "字段2" ,   "字段3" ,   "字段4" ,   "字段5" ,   "字段6" ,   "字段7" ,   "字段8" ,   "字段9" ,   "字段10" ,   "字段11" ,   "字段12" ,   "字段13" ,   "字段14" ,   "字段15"  };
        String[][] dataList = new String[arContentChilds.size()][23];

        for (int i = 0; i < arContentChilds.size(); i++) {

                        dataList[i][0] = String.valueOf(arContentChilds.get(i).getId());
                        dataList[i][1] = String.valueOf(arContentChilds.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(arContentChilds.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(arContentChilds.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(arContentChilds.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(arContentChilds.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(arContentChilds.get(i).getArContentId());
                        dataList[i][7] = String.valueOf(arContentChilds.get(i).getType());
                        dataList[i][8] = String.valueOf(arContentChilds.get(i).getRemark1());
                        dataList[i][9] = String.valueOf(arContentChilds.get(i).getRemark2());
                        dataList[i][10] = String.valueOf(arContentChilds.get(i).getRemark3());
                        dataList[i][11] = String.valueOf(arContentChilds.get(i).getRemark4());
                        dataList[i][12] = String.valueOf(arContentChilds.get(i).getRemark5());
                        dataList[i][13] = String.valueOf(arContentChilds.get(i).getRemark6());
                        dataList[i][14] = String.valueOf(arContentChilds.get(i).getRemark7());
                        dataList[i][15] = String.valueOf(arContentChilds.get(i).getRemark8());
                        dataList[i][16] = String.valueOf(arContentChilds.get(i).getRemark9());
                        dataList[i][17] = String.valueOf(arContentChilds.get(i).getRemark10());
                        dataList[i][18] = String.valueOf(arContentChilds.get(i).getRemark11());
                        dataList[i][19] = String.valueOf(arContentChilds.get(i).getRemark12());
                        dataList[i][20] = String.valueOf(arContentChilds.get(i).getRemark13());
                        dataList[i][21] = String.valueOf(arContentChilds.get(i).getRemark14());
                        dataList[i][22] = String.valueOf(arContentChilds.get(i).getRemark15());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

